Fixed Parse.pm and create-sysvinit-file.pl.
[darcs-mirror-metainit.git] / create-sysvinit-file.pl
1 #!/usr/bin/perl -w
2 #
3 # Creates a sysvinit file from a metainit description.
4
5 use Parse;
6
7 $filename = shift || die "Filename expected!\n";
8 # Parse the metainit in
9 %initparams = Parse::parse($filename);
10
11 # Print the "dynamic" part of the initskript
12 print << "EOF"
13 #! /bin/sh
14 ### BEGIN INIT INFO
15 # Provides:          $initparams{"Name"}
16 # Required-Start:    $initparams{"Required-Start"}
17 # Required-Stop:     $initparams{"Required-Stop"}
18 # Default-Start:     2 3 4 5
19 # Default-Stop:      0 1 6
20 ### END INIT INFO
21
22 # WARNING:
23 # This initscript has been autogenerated my metainit.
24 # Do not edit this file, but edit the corresponding metainit
25 # config.
26
27 # PATH should only include /usr/* if it runs after the mountnfs.sh script
28 PATH=/sbin:/usr/sbin:/bin:/usr/bin
29 DESC="Description of the service"
30 NAME=$initparams{"Name"}
31 DAEMON=$initparams{"Path"}
32 DAEMON_ARGS=$initparams{"Args"}
33 PIDFILE=/var/run/\$NAME.pid
34 SCRIPTNAME=/etc/init.d/\$NAME
35 EOF
36 ;
37
38 # ... and the rest of the initscript, that is identical for all
39 # metainit-created scripts.
40 print << 'EOF'
41 # Exit if the package is not installed
42 [ -x "$DAEMON" ] || exit 0
43
44 # Read configuration variable file if it is present
45 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
46
47 # Load the VERBOSE setting and other rcS variables
48 . /lib/init/vars.sh
49
50 # Define LSB log_* functions.
51 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
52 . /lib/lsb/init-functions
53
54 #
55 # Function that starts the daemon/service
56 #
57 do_start()
58 {
59         # Return
60         #   0 if daemon has been started
61         #   1 if daemon was already running
62         #   2 if daemon could not be started
63         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
64                 || return 1
65         start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
66                 $DAEMON_ARGS \
67                 || return 2
68         # Add code here, if necessary, that waits for the process to be ready
69         # to handle requests from services started subsequently which depend
70         # on this one.  As a last resort, sleep for some time.
71 }
72
73 #
74 # Function that stops the daemon/service
75 #
76 do_stop()
77 {
78         # Return
79         #   0 if daemon has been stopped
80         #   1 if daemon was already stopped
81         #   2 if daemon could not be stopped
82         #   other if a failure occurred
83         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
84         RETVAL="$?"
85         [ "$RETVAL" = 2 ] && return 2
86         # Wait for children to finish too if this is a daemon that forks
87         # and if the daemon is only ever run from this initscript.
88         # If the above conditions are not satisfied then add some other code
89         # that waits for the process to drop all resources that could be
90         # needed by services started subsequently.  A last resort is to
91         # sleep for some time.
92         start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
93         [ "$?" = 2 ] && return 2
94         # Many daemons don't delete their pidfiles when they exit.
95         rm -f $PIDFILE
96         return "$RETVAL"
97 }
98
99 #
100 # Function that sends a SIGHUP to the daemon/service
101 #
102 do_reload() {
103         #
104         # If the daemon can reload its configuration without
105         # restarting (for example, when it is sent a SIGHUP),
106         # then implement that here.
107         #
108         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
109         return 0
110 }
111
112 case "$1" in
113   start)
114         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
115         do_start
116         case "$?" in
117                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
118                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
119         esac
120         ;;
121   stop)
122         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
123         do_stop
124         case "$?" in
125                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
126                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
127         esac
128         ;;
129   #reload|force-reload)
130         #
131         # If do_reload() is not implemented then leave this commented out
132         # and leave 'force-reload' as an alias for 'restart'.
133         #
134         #log_daemon_msg "Reloading $DESC" "$NAME"
135         #do_reload
136         #log_end_msg $?
137         #;;
138   restart|force-reload)
139         #
140         # If the "reload" option is implemented then remove the
141         # 'force-reload' alias
142         #
143         log_daemon_msg "Restarting $DESC" "$NAME"
144         do_stop
145         case "$?" in
146           0|1)
147                 do_start
148                 case "$?" in
149                         0) log_end_msg 0 ;;
150                         1) log_end_msg 1 ;; # Old process is still running
151                         *) log_end_msg 1 ;; # Failed to start
152                 esac
153                 ;;
154           *)
155                 # Failed to stop
156                 log_end_msg 1
157                 ;;
158         esac
159         ;;
160   *)
161         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
162         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
163         exit 3
164         ;;
165 esac
166 EOF